<?php

use Joomla\CMS\Factory;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Uri\Uri;

// Check if we're in Joombla
$isInsideJoomla = class_exists('Joomla\CMS\Factory');
echo "<script>\n\tvar isInsideJoomla = " . json_encode($isInsideJoomla) . ";\n</script>\n";

if ($isInsideJoomla) {

    defined('_JEXEC') or die;
    // dont allow anyone in that isn't logged in, we need to create a list of whitelisted URLs, so far its only the versions JSON page
    $user = Factory::getUser();
    if ($user->guest == 1) {
        $return = base64_encode(Uri::getInstance());
        $login_url_with_return = Route::_('index.php?option=com_users&view=login&return=' . $return);
        Factory::getApplication()->redirect($login_url_with_return);
    }

    echo "<script src='components/com_jsonattributeexplorer/tiqGraphQLHelpers.js'></script>\n";
} else {
    echo "<script src='getToken.js'></script>\n";
    echo "<script src='tiqGraphQLHelpers.js'></script>\n";
    echo "<script src='https://code.jquery.com/jquery-3.3.1.js' integrity='sha256-2Kok7MbOyxpgUVvAk/HJ2jigOSYS2auK4Pfzbm7uH60=' crossorigin='anonymous'></script>\n";
    echo "<link href='https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css' rel='stylesheet'>\n";
    echo "<link rel='stylesheet' href='https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css' integrity='sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm' crossorigin='anonymous'>\n";
    echo "<script src='https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js' integrity='sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl' crossorigin='anonymous'></script>\n";
}

?>

<script src="media/com_thinkiq/js/dist/tiq.core.js"></script>
<script src="media/com_thinkiq/js/dist/tiq.components.js"></script>

<!-- item template -->
<script type="text/x-template" id="item-template">
    <li>
        <div
          :class="{bold: isFolder}"
          @click="toggle"
          @dblclick="makeFolder">
          <!-- <span v-if="isFolder">[{{ isOpen ? '-' : '+' }}]</span> -->
          <i v-if="isFolder" v-bind:class="isOpen ? 'fa fa-minus-square' : 'fa fa-plus-square'"
                style="font-size: 1em; color: #0069d9;"></i>
          <span @click="$emit('on-attribute-click', item.id)" v-bind:class="{'text-primary':item.id==activeattrid}">{{ item.name }}</span>
        </div>
        <ul v-show="isOpen" v-if="isFolder">
          <tree-item
            class="item"
            v-for="(child, index) in item.children"
            :key="index"
            :item="child"
            @make-folder="$emit('make-folder', $event)"
            @add-item="$emit('add-item', $event)"
            @on-attribute-click="onAttributeClick"
            :activeattrid="activeattrid"
          ></tree-item>
          <!-- <li class="add" @click="$emit('add-item', item)">+</li> -->
        </ul>
      </li>
    </script>

<style>
.item {
    cursor: pointer;
}

.bold {
    font-weight: bold;
}

ul {
    padding-left: 1em;
    line-height: 1.5em;
    list-style-type: none;
}

.tiq_ts_th {
    background-color: #c0d4d8;
}

.tiq_ts_td {
    background-color: #fbedd0;
}
</style>


<div id="app">

    <h1 class="pb-4 text-center">{{hardTitle ?? 'JSON Attribute Explorer'}}</h1>

    <div id="dp" class="d-flex flex-column align-items-center">

        <div class="row">
            <duration-picker ref="datePicker" :show-pan-controls="true" :show-time-periods="false" start-time="00:00:00"
                end-time="00:00:00" mode="date" :start-date="startDate.format('YYYY-MM-DD')"
                :end-date="endDate.format('YYYY-MM-DD')" :show-start-time="false" :show-end-time="false"
                @on_date_change="onDateChange" style="width:1000px">
            </duration-picker>
        </div>
    </div>

    <!-- the demo root element -->
    <div class="row">
        <div v-if="Object.keys(treeData).length > 0" class="col-2">
            <ul >
                <tree-item class="item" :item="treeData" @make-folder="makeFolder" @add-item="addItem"
                    @on-attribute-click="onAttributeClick" :activeattrid="activeAttrId"></tree-item>
            </ul>
        </div>


        <!-- <div style="height:350px; overflow-y: scroll;">
        <div v-for="aAttribute in attributes">
            <div class="d-flex w-100" @click="() => {onAttributeClick(aAttribute.id);}">
                {{aAttribute.displayName}} ({{aAttribute.fqn.join('/')}})
            </div>
        </div>
    </div> -->

        <!-- <div v-for="aRecord in records">
        {{aRecord.ts}}
        <textarea style="width: 100%; height: 100px">
                {{JSON.stringify(JSON.parse(aRecord.stringvalue), null, 2)}}
            </textarea>
    </div> -->
        <div v-bind:class="Object.keys(treeData).length === 0 ? 'col-12' : 'col-10'">
            <list :height="600" :set_width="false" :list_name="list_name" ref="attribute_list" :actions="actions"
                :columns="columns" :rows="rows" :title="title">
            </list>
        </div>
    </div>
</div>


<script>
// define the tree-item component
core.Vue.component("tree-item", {
    template: "#item-template",
    props: {
        item: Object,
        activeattrid: String
    },
    data: function() {
        return {
            isOpen: false
        };
    },
    computed: {
        isFolder: function() {
            return this.item.children && this.item.children.length;
        }
    },
    methods: {
        toggle: function() {
            if (this.isFolder) {
                this.isOpen = !this.isOpen;
            }
        },
        makeFolder: function() {
            if (!this.isFolder) {
                this.$emit("make-folder", this.item);
                this.isOpen = true;
            }
        },
        onAttributeClick: function(a) {
            this.$emit("on-attribute-click", a);

        },
    }
});

//create instance of the vuejs
var app = new core.Vue({
    el: "#app",
    components: {
        // "duration-picker": tiq.DurationPicker
    },
    data() {
        return {

            startDate: core.moment().add(-1, 'd'),
            endDate: core.moment(),

            attributes: [],
            records: [],

            columns: [],
            rows: [],

            treeData: {},

            activeAttrId: null,

            hardAttrId: <?php echo $_GET['attrId'] ?? 'null';  ?>,
            hardTitle: <?php echo $_GET['title'] ?? 'null';  ?>

        };
    },
    methods: {

        makeFolder: function(item) {
            Vue.set(item, "children", []);
            this.addItem(item);
        },
        addItem: function(item) {
            item.children.push({
                name: "new stuff"
            });
        },
        onAttributeClick: async function(a) {
            let this_vue = this;

            console.log(a);
            if (a != 0) {
                this_vue.activeAttrId = a;
            }

            getRawHistoryDataWithSamplingAsync([a], this_vue.startDate, this_vue.endDate).then((
                response) => {
                this_vue.records = response.sort((a, b) => a.ts < b.ts ? 1 : -1);
                this_vue.records.forEach(x => {
                    if (x.stringvalue != null) {
                        try {
                            x.jsonvalue = JSON.parse(x.stringvalue);
                        } catch (e) {

                        }
                    }
                });
                this_vue.columns = [];
                this_vue.rows = [];

                for (let recordIndex = 0; recordIndex < this_vue.records.length; recordIndex++) {

                    if (this_vue.records[recordIndex].jsonvalue) {
                        const aRecord = this_vue.records[recordIndex].jsonvalue;

                        if (Array.isArray(aRecord)) {
                            aHeaderRecord = aRecord[0];
                        } else {
                            aHeaderRecord = aRecord;
                        }

                        if (recordIndex == 0) {

                            this_vue.columns.push({
                                name: 'tiq_ts',
                                thClass: 'tiq_ts_th',
                                tdClass: 'tiq_ts_td',
                                title: 'tiq_ts',
                                field: 'tiq_ts',
                                show: true,
                                searchable: true,
                                toggleable: true
                            });


                            for (let colIndex = 0; colIndex < Object.keys(aHeaderRecord)
                                .length; colIndex++) {
                                const aColumn = Object.keys(aHeaderRecord)[colIndex];
                                this_vue.columns.push({
                                    name: aColumn,
                                    thClass: 'custom-th',
                                    tdClass: 'custom-td',
                                    title: aColumn,
                                    field: aColumn,
                                    show: true,
                                    searchable: true,
                                    toggleable: true
                                });
                            }
                        }


                        if (Array.isArray(aRecord)) {
                            for (let rowIndex = 0; rowIndex < aRecord.length; rowIndex++) {
                                aRecord[rowIndex].tiq_ts = this_vue.records[recordIndex].ts;
                                this_vue.rows.push(aRecord[rowIndex]);
                            }
                        } else {
                            aRecord.tiq_ts = this_vue.records[recordIndex].ts;
                            this_vue.rows.push(aRecord);
                        }


                    } else {
                        if (recordIndex == 0) {

                            this_vue.columns.push({
                                name: 'tiq_ts',
                                thClass: 'tiq_ts_th',
                                tdClass: 'tiq_ts_td',
                                title: 'tiq_ts',
                                field: 'tiq_ts',
                                show: true,
                                searchable: true,
                                toggleable: true
                            });

                            this_vue.columns.push({
                                name: 'tiq_value',
                                thClass: 'custom-th',
                                tdClass: 'custom-td',
                                title: 'tiq_value',
                                field: 'tiq_value',
                                show: true,
                                searchable: true,
                                toggleable: true
                            });
                        }
                        let aRecord = {};
                        aRecord.tiq_ts = this_vue.records[recordIndex].ts;
                        aRecord.tiq_value = this_vue.records[recordIndex].stringvalue;
                        this_vue.rows.push(aRecord);


                    }

                }
            });

        },


        onDateChange: function(start_date, end_date) {
            let this_vue = this;

            this_vue.startDate = core.moment(start_date);
            this_vue.endDate = core.moment(end_date);

            this.onAttributeClick(this_vue.activeAttrId);
        },



    },

    mounted() {

        let this_vue = this;

        let today = core.moment(core.moment().format(core.moment.HTML5_FMT.DATE), core.moment
            .HTML5_FMT
            .DATE);
        this_vue.startDate = today.clone();
        this_vue.endDate = today.clone().add(1, 'd');

        let query = `
            {
                attributes(
                    filter: {dataType: {equalTo: STRING}, dataSource: {notEqualTo: CONFIG}}
                ) {
                    id
                    displayName
                    fqn
                }
            }
        `;

        if(this_vue.hardAttrId != null ) {
            this_vue.activeAttrId=String(this_vue.hardAttrId);
            this_vue.onAttributeClick(this_vue.activeAttrId);
        } else {
            makeRequestAsync(query).then((response) => {

                this_vue.attributes = response.data.attributes.sort((a, b) => (a.fqn.join(
                        '/') > b.fqn
                    .join(
                        '/')) ? 1 : -1);

                let treeData = {};

                for (let attributeIndex = 0; attributeIndex < this_vue.attributes
                    .length; attributeIndex++) {
                    const element = this_vue.attributes[attributeIndex];

                    if (Object.keys(treeData).length===0) {
                        treeData = {
                            name: element.fqn[0],
                            children: []
                        }
                    }

                    let currentNode = treeData;
                    for (let fqnIndex = 1; fqnIndex < element.fqn.length; fqnIndex++) {
                        const leaf = element.fqn[fqnIndex];
                        let aChildLeaf = currentNode.children.find(x => x.name == leaf);
                        if (!aChildLeaf) {
                            aChildLeaf = {
                                name: leaf,
                                children: [],
                                id: fqnIndex == element.fqn.length - 1 ? element.id : 0
                            }
                            currentNode.children.push(aChildLeaf);
                        }
                        currentNode = aChildLeaf;
                    }

                }

                this_vue.treeData = treeData;

            });
        }



    },
});
</script>